#the closest thing to writing raw ASM
import re

code = """#TESM INTERPRETER
LOL 06 0000 #program counter
LOL 01 0001 #put
LOL 02 0002 #vput
LOL 03 0003 #prnt
LOL 04 0004 #equl
LOL 05 0005 #vequl
"""

out = """#include <stdint.h>

int8_t PRG_BIN[] = {
  """

def writeHex(str):
    global out
    out += f"{str}, "

count = 1
for i in re.split("\n| ",code):
    match i:
        case "INC":
            writeHex("0x01")
        case "IRA":
            writeHex("0x02")
        case "IRX":
            writeHex("0x03")
        case "IRY":
            writeHex("0x04")
        case "DNC":
            writeHex("0x05")
        case "DCA":
            writeHex("0x06")
        case "DCX":
            writeHex("0x07")
        case "DCY":
            writeHex("0x07")
        case "JEA":
            writeHex("0x10")
        case "JER":
            writeHex("0x11")
        case "JML":
            writeHex("0x1A")
        case "JMA":
            writeHex("0x1B")
        case "LXA":
            writeHex("0x20")
        case "LXL":
            writeHex("0x21")
        case "LYA":
            writeHex("0x22")
        case "LYL":
            writeHex("0x23")
        case "LAA":
            writeHex("0x24")
        case "LAL":
            writeHex("0x25")
        case "LOA":
            writeHex("0x26")
        case "LOL":
            writeHex("0x27")
        case "STX":
            writeHex("0x2A")
        case "STY":
            writeHex("0x2B")
        case "STA":
            writeHex("0x2C")
        case "DBG":
            writeHex("0xFF")
        case other:
            if len(i) == 4: #assume memory address
                writeHex(f"0x{i[0]+i[1]}")
                writeHex(f"0x{i[2]+i[3]}")
            elif len(i) == 2:
                writeHex(f"0x{i}")
            #else:
            #    writeHex("0x00")
    count+=1

out = out.rstrip(", ")
out += f""", 0xFC
}};
int PRG_LEN = {count};
"""
print(out)