#reads TESM code, outputs rawASM
code = """vput 1 0
vput 1 4
vput 1 6
prnt
jmp 0
dump"""

OFFSET = 0x00FF #how far into memory should we store TESM memory banks

prc = 0
hist = []

def intToHex(addr, video=False):
    addr = int(addr)
    if video:
        if addr > 7:
            return OFFSET+16+7 #clamp value
        return OFFSET+16+addr
    else:
        if addr > 15:
            return OFFSET+15 #clamp value
        return OFFSET+addr

def hexstr(integer, len=2, inc=True):
    global prc
    if inc:
        prc+=int(len/2)
    return "{0:0{1}x}".format(integer, len)

for line in code.split("\n"):
    inst = line.split(" ")
    match inst[0]:
        case "put":
            hist.append(prc)
            print(f"LOL {hexstr(int(inst[1]))} {hexstr(intToHex(inst[2]), 4)}")
            prc+=1
        case "vput":
            hist.append(prc)
            print(f"LOL {hexstr(int(inst[1]))} {hexstr(intToHex(inst[2], True), 4)}")
            prc+=1
        case "equl":
            hist.append(prc)
            arg1 = hexstr(intToHex(inst[1]), 4)
            arg2 = hexstr(intToHex(inst[2]), 4)
            arg3 = hexstr(intToHex(inst[3]), 4)
            print(f"""JEA {arg1} {arg2} {hexstr(prc+5,4,False)}
JML {hexstr(prc+9,4,False)}
LOL {hexstr(1,2,False)} {arg3}""")
            prc+=8
        case "vequl":
            hist.append(prc)
            arg1 = hexstr(intToHex(inst[1], True), 4)
            arg2 = hexstr(intToHex(inst[2], True), 4)
            arg3 = hexstr(intToHex(inst[3], True), 4)
            print(f"""JEA {arg1} {arg2} {hexstr(prc+5,4,False)}
JML {hexstr(prc+9,4,False)}
LOL {hexstr(1,2,False)} {arg3}""")
            prc+=8
        case "cpy":
            hist.append(prc)
            arg1 = hexstr(intToHex(inst[1]), 4)
            arg2 = hexstr(intToHex(inst[2], True), 4)
            print(f"""LOA {arg1} {arg2}""")
            prc+=5
        case "mov":
            hist.append(prc)
            arg1 = hexstr(intToHex(inst[1]), 4)
            arg2 = hexstr(intToHex(inst[2], True), 4)
            print(f"""LOA {arg1} {arg2}
LOL {hexstr(0,2,False)} {arg1}""")
            prc+=9
        case "prnt":
            hist.append(prc)
            print(f"""LOL 01 0117
LOL 00 0117""")
            prc+=7
        case "jmp":
            hist.append(prc)
            print(f"""JML {hexstr(hist[int(inst[1])],4,False)}""")
            prc+=3
        case "dump":
            hist.append(prc)
            print("DBG")
            prc+=1
        case "vdump":
            hist.append(prc)
            print("DBG")
            prc+=1
        case other:
            hist.append(prc)
            print("NOP")
            prc+=1