#include "constants.h"

#include <stdint.h>
#include <stdio.h>
#include <unistd.h>

void memview() {
	for (int i = 0x00; i <= 0xFFFF; i++) {
		if (memory[i] != 0x00) {
			printf("Mem Address 0x%04X: 0x%04X\n", i, memory[i]);
		}
	}
	printf("rax - %d\n", irx);
	printf("ray - %d\n", iry);
	printf("acc - %d\n", acc);
	printf("prc - %d\n", prc);
}

int emulate(uint8_t exec[], int size, uint8_t addr) {
	//uint8_t* program = (uint8_t*)exec;
	/*for (int i = addr, i2=0; i < size+addr; i++) {
		memory[i] = exec[i2];
		i2++;
	}*/ //not needed: LRIS has separate prgrom

	while (prc < UINT16_MAX) { //FIXME: this can cause a vuln where you can at least read OOB memory (jumping past the 0xFC)
		uint8_t inst = exec[prc];
		switch (inst) {
			case 0x00: //NOP
				break;
			case 0x03: //INC RX
				irx++;
				break;
			case 0x04: //INC RY
				iry++;
				break;
			case 0x10: { //A/L JIE
				uint8_t upper = exec[++prc];
				uint8_t lower = exec[++prc];
				uint16_t addr1 = 256U*upper+lower;
				upper = exec[++prc];
				lower = exec[++prc];
				uint16_t addr2 = 256U*upper+lower;
				upper = exec[++prc];
				lower = exec[++prc];
				uint16_t newPRC = 256U*upper+lower;
				if (memory[addr1] == memory[addr2]) {
					prc = newPRC-1; //we need to account for the prc++ at the end of the loop
				} else { /* DO NOTHING */ }
				break;
			}
			case 0x1A: { //LITERAL JMP
				uint8_t upper = exec[++prc];
				uint8_t lower = exec[++prc];
				uint16_t addr = 256U*upper+lower;
				prc = memory[addr]-1;
				break;
			}
			case 0x20: { //ABSOLUTE LDX
				uint8_t upper = exec[++prc];
				uint8_t lower = exec[++prc];
				uint16_t addr = 256U*upper+lower;
				irx = memory[addr];
				break;
			}
			case 0x23: { //LITERAL LDY
				uint8_t val = exec[++prc];
				iry = val;
				break;
			}
			case 0x26: { //ABSOLUTE LOD
				uint8_t upper = exec[++prc];
				uint8_t lower = exec[++prc];
				uint16_t addr1 = 256U*upper+lower;
				upper = exec[++prc];
				lower = exec[++prc];
				uint16_t addr2 = 256U*upper+lower;
				memory[addr2] = memory[addr1];
				break;
			}
			case 0x27: { //LITERAL LOD
				uint8_t val = exec[++prc];
				uint8_t upper = exec[++prc];
				uint8_t lower = exec[++prc];
				uint16_t addr = 256U*upper+lower;
				memory[addr] = val;
				break;
			}
			case 0x2B: { //STY
				uint8_t upper = exec[++prc];
				uint8_t lower = exec[++prc];
				uint16_t addr = 256U*upper+lower;
				memory[addr] = iry;
				break;
			}
			case 0x50:
				acc = ~(irx & iry);
			case 0xFC:
				_exit(0);
			case 0xFF:
				memview();
				break;
			default:
				printf("Opcode 0x%02X\n not implemented!\n", inst);
				memview();
				_exit(0);
		}
		//printf("Ran inst 0x%02X\n", inst);
		//memview();
		prc++;

		if (memory[0x010F+8]) {
			int charcode = 0;
			if (memory[0x010F]) {
				charcode += 64;
				//printf("%d\n", charcode);
			}
			if (memory[0x0110]) {
				charcode += 32;
				//printf("%d\n", charcode);
			}
			if (memory[0x0111]) {
				charcode += 16;
				//printf("%d\n", charcode);
			}
			if (memory[0x0112]) {
				charcode += 8;
				//printf("%d\n", charcode);
			}
			if (memory[0x0113]) {
				charcode += 4;
				//printf("%d\n", charcode);
			}
			if (memory[0x0114]) {
				charcode += 2;
				//printf("%d\n", charcode);
			}
			if (memory[0x0115]) {
				charcode += 1;
				//printf("%d\n", charcode);
			}
			printf("%c%c", charcode, memory[0x0116] ? '\n' : 0x0);
		}
	}
	printf("out of length");
	return 0;
}
